#ifndef __CDRIVER_H_BY_BYCON__
#define __CDRIVER_H_BY_BYCON__
#include <shlwapi.h>
#include <tchar.h>
#include <winsvc.h>

#pragma   comment(lib,"shlwapi.lib") 

class CDriver
{
public:
	CDriver(LPCTSTR lpszDriverSysName ,LPCTSTR lpszLinkName);
	virtual ~CDriver();

protected:
	HANDLE m_hDevice;
	char m_szLinkName[64];	// 
	
	BOOL m_bStarted;	// ָǷ
	BOOL m_bCreateService;	// ָǷ񴴽˷
	
	HANDLE m_hSCM;		// SCMݿ
	HANDLE m_hService;	// 

public:
	// 
	// Ƿ
	virtual BOOL IsValid() { return (m_hSCM != NULL || m_hService != NULL); }
	
	// 
	// Ҳ˵DriverEntry
	virtual BOOL StartDriver();
	// 񡣼DriverUnload̽
	virtual BOOL StopDriver();
	
	// 豸ȡõһ
	virtual BOOL OpenDevice();
	
	// 豸Ϳƴ
	virtual DWORD IoControl(DWORD nCode, PVOID pInBuffer, 
		DWORD nInCount, PVOID pOutBuffer, DWORD nOutCount);


};


CDriver::CDriver(LPCTSTR lpszDriverSysName, LPCTSTR lpszLinkName)
{
	
	strncpy(m_szLinkName, lpszLinkName, 64);
	m_bStarted = FALSE;
	m_bCreateService = FALSE;
	m_hSCM = m_hService = NULL;
	m_hDevice = INVALID_HANDLE_VALUE;

	TCHAR szDriver[MAX_PATH];
	::GetModuleFileName( NULL, szDriver, MAX_PATH );
	lstrcpy( _tcsrchr( szDriver, _T('\\') ) + 1, lpszDriverSysName );
	if( !PathFileExists( szDriver ) )
	{
		return;
	}

	// SCM
	m_hSCM = ::OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if(m_hSCM == NULL)
	{
		MessageBox(0, "򿪷ƹʧ\n", 
				"ΪӵAdministratorȨ\n", 0);
		return;
	}

	// 򿪷
	m_hService = ::CreateService(m_hSCM, m_szLinkName, m_szLinkName, SERVICE_ALL_ACCESS, 
				SERVICE_KERNEL_DRIVER, SERVICE_DEMAND_START, SERVICE_ERROR_NORMAL, 
				szDriver, NULL, 0, NULL, NULL, NULL);
	if(m_hService == NULL)
	{
		int nError = ::GetLastError();
		if(nError == ERROR_SERVICE_EXISTS || nError == ERROR_SERVICE_MARKED_FOR_DELETE)
		{
			m_hService = ::OpenService(m_hSCM, m_szLinkName, SERVICE_ALL_ACCESS);
			if (m_hService == NULL)
			{
				m_bCreateService = TRUE;
			}
		}
	}
	else
	{
		m_bCreateService = TRUE;
	}
}

CDriver::~CDriver()
{
	if(m_hDevice != INVALID_HANDLE_VALUE)
		::CloseHandle(m_hDevice);

	StopDriver();
	
	if(m_bCreateService)
		::DeleteService(m_hService);	

	if(m_hService != NULL)
		::CloseServiceHandle(m_hService);
	if(m_hSCM != NULL)
		::CloseServiceHandle(m_hSCM);
}

BOOL CDriver::StartDriver()
{
	if(m_bStarted)
		return TRUE;
	if(m_hService == NULL)
		return FALSE;

	if(!::StartService(m_hService, 0, NULL))
	{
		int nError = ::GetLastError();
		if(nError == ERROR_SERVICE_ALREADY_RUNNING)
			m_bStarted = TRUE;
		else
		{
			MessageBox(NULL,"ʧ!",":",MB_OK);
			::DeleteService(m_hService);
		}
	}
	else
	{
		// ɹ󣬵ȴ״̬
		int nTry = 0;
		SERVICE_STATUS ss;
		::QueryServiceStatus(m_hService, &ss);
		while(ss.dwCurrentState == SERVICE_START_PENDING && nTry++ < 80)
		{
			::Sleep(50);
			::QueryServiceStatus(m_hService, &ss);
		}
		if(ss.dwCurrentState == SERVICE_RUNNING)
			m_bStarted = TRUE;
	}
	return m_bStarted;
}

BOOL CDriver::StopDriver()
{
	if(!m_bStarted)
		return TRUE;
	if(m_hService == NULL)
		return FALSE;

	SERVICE_STATUS ss;
	if(!::ControlService(m_hService, SERVICE_CONTROL_STOP, &ss))
	{
		if(::GetLastError() == ERROR_SERVICE_NOT_ACTIVE)
			m_bStarted = FALSE;
	}
	else
	{
		// ȴȫֹͣ
		int nTry = 0;
		while(ss.dwCurrentState == SERVICE_STOP_PENDING && nTry++ < 80)
		{
			::Sleep(50);
			::QueryServiceStatus(m_hService, &ss);
		}
		if(ss.dwCurrentState == SERVICE_STOPPED)
			m_bStarted = FALSE;
	}
	return !m_bStarted;
}

BOOL CDriver::OpenDevice()
{
	if(m_hDevice != INVALID_HANDLE_VALUE)
		return TRUE;

	char sz[256] = "";
	wsprintf(sz, "\\\\.\\%s", m_szLinkName);
	// 򿪵豸ľ
	m_hDevice = ::CreateFile(sz,
		GENERIC_READ | GENERIC_WRITE,
		0,
		NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL|FILE_FLAG_OVERLAPPED,
		NULL);

	return (m_hDevice != INVALID_HANDLE_VALUE);
}

DWORD CDriver::IoControl(DWORD nCode, PVOID pInBuffer, 
		DWORD nInCount, PVOID pOutBuffer, DWORD nOutCount)
{
	if(m_hDevice == INVALID_HANDLE_VALUE)
		return -1;
	// Ϳƴ
	DWORD dwBytesReturn;

	BOOL bRet = ::DeviceIoControl(m_hDevice, nCode, 
		pInBuffer, nInCount, pOutBuffer, nOutCount, &dwBytesReturn, NULL);

	if(bRet)
		return dwBytesReturn;
	else
		return -1;
	
}

#endif



